[Check Task Description](#task-description "Go to Task Description")

## Installation ##

Clone the main repository at https://github.com/OYousryB/chatSystemAssignment
```
git clone git@github.com:OYousryB/chatSystemAssignment.git
```

### Install For Docker

#### 1. Pre-requisites

1. [Install Docker](https://docs.docker.com/install/linux/docker-ce/ubuntu/)
2. [Install Docker Compose](https://docs.docker.com/compose/install/#install-compose)

#### 2. Installation

```
$ cd chatSystemAssignment
Use either one
$ make compose_up
$ docker-compose up
```
Wait for all services to be up and running, don't close the terminal

#### 3. test Connection

```	
http://0.0.0.0:3333/	
curl -X GET \	
  http://0.0.0.0:3333/ \	
  -H 'content-type: application/json'	
```

#### 4. Run Rspec

In a new terminal
```
$ docker exec -it chatsystemassignment_rails_1 /bin/sh -c "[ -e /bin/bash ] && /bin/bash || /bin/sh"
$ cd /app/assignment/
$ make rspec
```

#### 5. Requests

***Using postman; Import collection & enviroment variables from postman folder***

**You need to request an authentication first**

curl -X POST http://0.0.0.0:3333/auth_tokens/ -H 'Content-Type: application/json'

***Go Post Requests***

**You need first to inspect rails public ip**

`docker inspect -f '{{range .NetworkSettings.Networks}}{{.IPAddress}}{{end}}' chatsystemassignment_rails_1`

Use IPAddress retreived in go app requests
```
curl -X POST -H "Authorization-Key: sZtAcWx4Uv38yT1aKaCzCg1569525372540" -d "{\"host\": \"172.26.0.6\", \"name\": \"InsertName\"}" http://localhost:8080?req=application
curl -X POST -H "Authorization-Key: sZtAcWx4Uv38yT1aKaCzCg1569525372540" -d "{\"host\": \"172.19.0.6\", \"application_token\": \"InsertAppToken\"}" http://localhost:8080?req=chat
curl -X POST -H "Authorization-Key: sZtAcWx4Uv38yT1aKaCzCg1569525372540" -d "{\"host\": \"172.26.0.6\", \"application_token\": \"ycdjfWJHm2RpwSocKsVcxA1569543500256\", \"chat_number\": \"1\", \"content\": \"InsertContent\"}" http://localhost:8080?req=message
```


## Task Description ##

* It’s required to build a chat system.

* The system should allow creating new applications 
  * Each application will have a token(generated by the system) and a name(provided by the client).
  * The token is the identifier that devices use to send chats to that application.
  * Each application can have many chats.
 
* chat Creation.
  * A chat should have a number.
  * Numbering of chats in each application starts from 1
  * No 2 chats in the same application may have the same number.
  * The number of the chat should be returned in the chat creation request.

* Message Creation.
  * A chat contains messages 
  * messages have numbers that start from 1 for each chat.
  * The number of the message should also be returned in the message creation request.

* The client should never see the ID of any of the entities.

* Identification
  * The client identifies the application by its token
  * The chat by its number along with the application token.

* Add an endpoint for searching through messages of a specific chat
  * It should be able to partially match messages’ bodies.
  * You must use `ElasticSearch` for this.

* Specifications
  * The applications table should contain a column called `chats_count` 
    * that contains the number of chats for this application.
  * Similarly, the chats table should contain a column called `messages_count`
    * that contains the number of messages in this chat.
  * These columns don’t have to be live. However, they shouldn’t be lagging more than 1 hour.

* Assume that the system is to receive many requests. It might be running on multiple servers in parallel and thus multiple requests may be processed concurrently. Make sure to handle race conditions.

* Try to minimize the queries and avoid writing directly to MySQL while serving the requests(especially for the chats and messages creation endpoints). You can use a queuing system to achieve that.

* It is allowed for chats and messages to take time to be persisted.

* You should optimize your tables by adding appropriate indices.

* Your app should be containerized. We will only write `docker-compose up` to run the whole stack if it doesn’t work the task fails.

### Notes

1. You’re only asked to build the API. No GUI is required.
2. You should use Ruby on Rails(V5) for building the API and the workers. `BONUS: You are encouraged to have the endpoints of chats and messages creation as a Golang app.`
3. The endpoints should be RESTful.
   1. You should provide endpoints for creating, updating and reading applications
   2. Chats that belong to a specific application (GET/applications/[application_token]/chats) 
   3. Messages that belong to a specific chat.
   4. `Make sure to have appropriate indices in place for these endpoints to be optimized.`
4. Use MySQL as your main datastore. You’re allowed to use any other component you need along with MySQL. You may want to check out REDIS.
5. You should add a Readme containing instructions to run your code.
6. BONUS: Write specs for your code.
